﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using Telerik.Windows.Controls.GanttView;

namespace GanttSizingAndScrolling_Ticket744587
{
    public class SoftwarePlanning : ObservableCollection<IGanttTask>
    {
        public SoftwarePlanning()
        {
            var scopeTaskChild1 = new GanttTask(new DateTime(2012, 1, 3, 8, 0, 0), new DateTime(2012, 1, 3, 12, 0, 0), "Determine project scope");

            var scopeTaskChild2 = new GanttTask(new DateTime(2012, 1, 3, 13, 0, 0), new DateTime(2012, 1, 4, 12, 0, 0), "Secure project sponsorship");
            var scopeTaskChild3 = new GanttTask(new DateTime(2012, 1, 4, 13, 0, 0), new DateTime(2012, 1, 5, 12, 0, 0), "Define preliminary resources");
            var scopeTaskChild4 = new GanttTask(new DateTime(2012, 1, 5, 13, 0, 0), new DateTime(2012, 1, 6, 0, 0, 0), "Secure core resources");
            var scopeTaskChild5 = new GanttTask(new DateTime(2012, 1, 6, 0, 0, 0), new DateTime(2012, 1, 6, 0, 0, 0), "Scope complete");

            scopeTaskChild2.Dependencies.Add(new Dependency { FromTask = scopeTaskChild1 });
            scopeTaskChild3.Dependencies.Add(new Dependency { FromTask = scopeTaskChild2 });
            scopeTaskChild4.Dependencies.Add(new Dependency { FromTask = scopeTaskChild3 });
            scopeTaskChild5.Dependencies.Add(new Dependency { FromTask = scopeTaskChild4 });

            var scopeTask = new GanttTask(new DateTime(2012, 1, 3, 8, 0, 0), new DateTime(2012, 1, 6), "Scope")
            {
                Children = { scopeTaskChild1, scopeTaskChild2, scopeTaskChild3, scopeTaskChild4, scopeTaskChild5 }
            };
            this.Add(scopeTask);

            var softwareRequirementsTaskChild1 = new GanttTask(new DateTime(2012, 1, 6, 13, 0, 0), new DateTime(2012, 1, 13, 0, 0, 0), "Conduct needs analysis");
            var softwareRequirementsTaskChild2 = new GanttTask(new DateTime(2012, 1, 13, 13, 0, 0), new DateTime(2012, 1, 18, 0, 0, 0), "Draft preliminary software specifications");
            var softwareRequirementsTaskChild3 = new GanttTask(new DateTime(2012, 1, 18, 13, 0, 0), new DateTime(2012, 1, 20, 0, 0, 0), "Develop preliminary budget");
            var softwareRequirementsTaskChild4 = new GanttTask(new DateTime(2012, 1, 21, 8, 0, 0), new DateTime(2012, 1, 21, 17, 0, 0), "Review software specifications/budget with team");
            var softwareRequirementsTaskChild5 = new GanttTask(new DateTime(2012, 1, 21, 8, 0, 0), new DateTime(2012, 1, 21, 17, 0, 0), "Incorporate feedback on software specifications");
            var softwareRequirementsTaskChild6 = new GanttTask(new DateTime(2012, 1, 24, 8, 0, 0), new DateTime(2012, 1, 24, 17, 0, 0), "Develop delivery timeline");
            var softwareRequirementsTaskChild7 = new GanttTask(new DateTime(2012, 1, 25, 8, 0, 0), new DateTime(2012, 1, 25, 12, 0, 0), "Obtain approvals to proceed (concept, timeline, budget)");
            var softwareRequirementsTaskChild8 = new GanttTask(new DateTime(2012, 1, 25, 13, 0, 0), new DateTime(2012, 1, 26, 0, 0, 0), "Secure required resources");
            var softwareRequirementsTaskChild9 = new GanttTask(new DateTime(2012, 1, 26, 0, 0, 0), new DateTime(2012, 1, 26, 0, 0, 0), "Analysis complete");

            softwareRequirementsTaskChild2.Dependencies.Add(new Dependency { FromTask = softwareRequirementsTaskChild1 });
            softwareRequirementsTaskChild3.Dependencies.Add(new Dependency { FromTask = softwareRequirementsTaskChild2 });
            softwareRequirementsTaskChild4.Dependencies.Add(new Dependency { FromTask = softwareRequirementsTaskChild3 });
            softwareRequirementsTaskChild5.Dependencies.Add(new Dependency { FromTask = softwareRequirementsTaskChild4 });
            softwareRequirementsTaskChild6.Dependencies.Add(new Dependency { FromTask = softwareRequirementsTaskChild5 });
            softwareRequirementsTaskChild7.Dependencies.Add(new Dependency { FromTask = softwareRequirementsTaskChild6 });
            softwareRequirementsTaskChild8.Dependencies.Add(new Dependency { FromTask = softwareRequirementsTaskChild7 });
            softwareRequirementsTaskChild9.Dependencies.Add(new Dependency { FromTask = softwareRequirementsTaskChild8 });

            var softwareRequirementsTask = new GanttTask(new DateTime(2012, 1, 6, 13, 0, 0), new DateTime(2012, 1, 26), "Analysis/Software Requirements")
            {
                Children = { softwareRequirementsTaskChild1, softwareRequirementsTaskChild2, softwareRequirementsTaskChild3, softwareRequirementsTaskChild4, softwareRequirementsTaskChild5, softwareRequirementsTaskChild6, softwareRequirementsTaskChild7, softwareRequirementsTaskChild8, softwareRequirementsTaskChild9 }
            };

            this.Add(softwareRequirementsTask);

            var designTaskChild1 = new GanttTask(new DateTime(2012, 1, 26, 0, 0, 0), new DateTime(2012, 1, 28, 0, 0, 0), "Review preliminary software specifications");
            var designTaskChild2 = new GanttTask(new DateTime(2012, 1, 28, 13, 0, 0), new DateTime(2012, 2, 4, 0, 0, 0), "Develop functional specifications");
            var designTaskChild3 = new GanttTask(new DateTime(2012, 2, 4, 13, 0, 0), new DateTime(2012, 2, 10, 0, 0, 0), "Develop prototype based on functional specifications");
            var designTaskChild4 = new GanttTask(new DateTime(2012, 2, 10, 8, 0, 0), new DateTime(2012, 2, 14, 17, 0, 0), "Review functional specifications");
            var designTaskChild5 = new GanttTask(new DateTime(2012, 2, 14, 8, 0, 0), new DateTime(2012, 2, 15, 17, 0, 0), "Incorporate feedback into functional specifications");
            var designTaskChild6 = new GanttTask(new DateTime(2012, 2, 15, 8, 0, 0), new DateTime(2012, 2, 15, 17, 0, 0), "Obtain approval to proceed");
            var designTaskChild7 = new GanttTask(new DateTime(2012, 2, 25, 0, 0, 0), new DateTime(2012, 1, 25, 0, 0, 0), "Design complete");

            designTaskChild2.Dependencies.Add(new Dependency { FromTask = designTaskChild1 });
            designTaskChild3.Dependencies.Add(new Dependency { FromTask = designTaskChild2 });
            designTaskChild4.Dependencies.Add(new Dependency { FromTask = designTaskChild3 });
            designTaskChild5.Dependencies.Add(new Dependency { FromTask = designTaskChild4 });
            designTaskChild6.Dependencies.Add(new Dependency { FromTask = designTaskChild5 });
            designTaskChild7.Dependencies.Add(new Dependency { FromTask = designTaskChild6 });

            var designTask = new GanttTask(new DateTime(2012, 1, 6, 13, 0, 0), new DateTime(2012, 1, 26), "Analysis/Software Requirements")
            {
                Children = { designTaskChild1, designTaskChild2, designTaskChild3, designTaskChild4, designTaskChild5, designTaskChild6, designTaskChild7 }
            };
            this.Add(designTask);

            var developmentTaskChild1 = new GanttTask(new DateTime(2012, 2, 16, 8, 0, 0), new DateTime(2012, 2, 16, 17, 0, 0), "Review functional specifications");
            var developmentTaskChild2 = new GanttTask(new DateTime(2012, 2, 17, 8, 0, 0), new DateTime(2012, 2, 17, 17, 0, 0), "Identify modular/tiered design parameters");
            var developmentTaskChild3 = new GanttTask(new DateTime(2012, 2, 18, 8, 0, 0), new DateTime(2012, 2, 18, 17, 0, 0), "Assign development staff");
            var developmentTaskChild4 = new GanttTask(new DateTime(2012, 2, 21, 8, 0, 0), new DateTime(2012, 3, 10, 17, 0, 0), "Develop code");
            var developmentTaskChild5 = new GanttTask(new DateTime(2012, 2, 14, 15, 0, 0), new DateTime(2012, 3, 16, 15, 0, 0), "Developer testing (primary debugging)");
            var developmentTaskChild6 = new GanttTask(new DateTime(2012, 3, 16, 15, 0, 0), new DateTime(2012, 3, 16, 15, 0, 0), "Development complete");

            developmentTaskChild2.Dependencies.Add(new Dependency { FromTask = developmentTaskChild1 });
            developmentTaskChild3.Dependencies.Add(new Dependency { FromTask = developmentTaskChild2 });
            developmentTaskChild4.Dependencies.Add(new Dependency { FromTask = developmentTaskChild3 });
            developmentTaskChild5.Dependencies.Add(new Dependency { FromTask = developmentTaskChild4 });
            developmentTaskChild6.Dependencies.Add(new Dependency { FromTask = developmentTaskChild5 });


            var developmentTask = new GanttTask(new DateTime(2012, 2, 16, 8, 0, 0), new DateTime(2012, 3, 17), "Development")
            {
                Children = { developmentTaskChild1, developmentTaskChild2, developmentTaskChild3, developmentTaskChild4, developmentTaskChild5, developmentTaskChild6 }
            };
            this.Add(developmentTask);

            var testingTaskChild1 = new GanttTask(new DateTime(2012, 2, 16, 8, 0, 0), new DateTime(2012, 2, 21, 17, 0, 0), "Develop unit test plans using product specifications");
            var testingTaskChild2 = new GanttTask(new DateTime(2012, 2, 16, 8, 0, 0), new DateTime(2012, 2, 21, 17, 0, 0), "Develop integration test plans using product specifications");
            var testingTaskChild3 = new GanttTask(new DateTime(2012, 3, 16, 8, 0, 0), new DateTime(2012, 4, 6, 17, 0, 0), "Unit testing");
            var testingTaskChild4 = new GanttTask(new DateTime(2012, 4, 6, 8, 0, 0), new DateTime(2012, 4, 24, 17, 0, 0), "Integration Testing");

            testingTaskChild2.Dependencies.Add(new Dependency { FromTask = testingTaskChild1 });
            testingTaskChild3.Dependencies.Add(new Dependency { FromTask = testingTaskChild2 });
            testingTaskChild4.Dependencies.Add(new Dependency { FromTask = testingTaskChild3 });

            var testingTask = new GanttTask(new DateTime(2012, 2, 16, 8, 0, 0), new DateTime(2012, 4, 24), "Testing")
            {
                Children = { testingTaskChild1, testingTaskChild2, testingTaskChild3, testingTaskChild4 }
            };
            this.Add(testingTask);

            var trainingTaskChild1 = new GanttTask(new DateTime(2012, 2, 16, 8, 0, 0), new DateTime(2012, 2, 18, 17, 0, 0), "Develop training specifications for end users");
            var trainingTaskChild2 = new GanttTask(new DateTime(2012, 2, 16, 8, 0, 0), new DateTime(2012, 2, 18, 17, 0, 0), "Develop training specifications for helpdesk support staff");
            var trainingTaskChild3 = new GanttTask(new DateTime(2012, 2, 16, 8, 0, 0), new DateTime(2012, 2, 17, 17, 0, 0), "Identify training delivery methodology (computer based training, classroom, etc.)");
            var trainingTaskChild4 = new GanttTask(new DateTime(2012, 3, 15, 15, 0, 0), new DateTime(2012, 4, 6, 15, 0, 0), "Develop training materials");
            var trainingTaskChild5 = new GanttTask(new DateTime(2012, 4, 6, 15, 0, 0), new DateTime(2012, 4, 12, 15, 0, 0), "Conduct training usability study");
            var trainingTaskChild6 = new GanttTask(new DateTime(2012, 4, 12, 15, 0, 0), new DateTime(2012, 4, 17, 15, 0, 0), "Finalize training materials");
            var trainingTaskChild7 = new GanttTask(new DateTime(2012, 4, 17, 15, 0, 0), new DateTime(2012, 4, 19, 15, 0, 0), "Develop training delivery mechanism");
            var trainingTaskChild8 = new GanttTask(new DateTime(2012, 4, 19, 15, 0, 0), new DateTime(2012, 4, 19, 15, 0, 0), "Training materials complete");

            trainingTaskChild2.Dependencies.Add(new Dependency { FromTask = trainingTaskChild1 });
            trainingTaskChild3.Dependencies.Add(new Dependency { FromTask = trainingTaskChild2 });
            trainingTaskChild4.Dependencies.Add(new Dependency { FromTask = trainingTaskChild3 });
            trainingTaskChild5.Dependencies.Add(new Dependency { FromTask = trainingTaskChild4 });
            trainingTaskChild6.Dependencies.Add(new Dependency { FromTask = trainingTaskChild5 });
            trainingTaskChild7.Dependencies.Add(new Dependency { FromTask = trainingTaskChild6 });
            trainingTaskChild8.Dependencies.Add(new Dependency { FromTask = trainingTaskChild7 });

            var trainingTask = new GanttTask(new DateTime(2012, 2, 16, 8, 0, 0), new DateTime(2012, 4, 19, 15, 0, 0), "Training")
            {
                Children = { trainingTaskChild1, trainingTaskChild2, trainingTaskChild3, trainingTaskChild4, trainingTaskChild5, trainingTaskChild6, trainingTaskChild7, trainingTaskChild8 }
            };
            this.Add(trainingTask);

            var documentationTaskChild1 = new GanttTask(new DateTime(2012, 2, 16, 8, 0, 0), new DateTime(2012, 2, 16, 17, 0, 0), "Develop Help specification");
            var documentationTaskChild2 = new GanttTask(new DateTime(2012, 3, 1, 12, 0, 0), new DateTime(2012, 3, 22, 12, 0, 0), "Develop Help system");
            var documentationTaskChild3 = new GanttTask(new DateTime(2012, 3, 22, 13, 0, 0), new DateTime(2012, 3, 27, 12, 0, 0), "Review Help documentation");
            var documentationTaskChild4 = new GanttTask(new DateTime(2012, 3, 27, 15, 0, 0), new DateTime(2012, 3, 29, 15, 0, 0), "Incorporate Help documentation feedback");
            var documentationTaskChild5 = new GanttTask(new DateTime(2012, 2, 16, 8, 0, 0), new DateTime(2012, 2, 17, 17, 0, 0), "Develop user manuals specifications");
            var documentationTaskChild6 = new GanttTask(new DateTime(2012, 3, 1, 15, 0, 0), new DateTime(2012, 3, 22, 15, 0, 0), "Develop user manuals");
            var documentationTaskChild7 = new GanttTask(new DateTime(2012, 3, 22, 15, 0, 0), new DateTime(2012, 3, 24, 15, 0, 0), "Review all user documentation");
            var documentationTaskChild8 = new GanttTask(new DateTime(2012, 3, 24, 15, 0, 0), new DateTime(2012, 3, 28, 15, 0, 0), "Incorporate user documentation feedback");
            var documentationTaskChild9 = new GanttTask(new DateTime(2012, 3, 29, 15, 0, 0), new DateTime(2012, 3, 29, 15, 0, 0), "Documentation complete");

            documentationTaskChild2.Dependencies.Add(new Dependency { FromTask = documentationTaskChild1 });
            documentationTaskChild3.Dependencies.Add(new Dependency { FromTask = documentationTaskChild2 });
            documentationTaskChild4.Dependencies.Add(new Dependency { FromTask = documentationTaskChild3 });
            documentationTaskChild5.Dependencies.Add(new Dependency { FromTask = documentationTaskChild4 });
            documentationTaskChild6.Dependencies.Add(new Dependency { FromTask = documentationTaskChild5 });
            documentationTaskChild7.Dependencies.Add(new Dependency { FromTask = documentationTaskChild6 });
            documentationTaskChild8.Dependencies.Add(new Dependency { FromTask = documentationTaskChild7 });

            var documentationTask = new GanttTask(new DateTime(2012, 2, 16, 8, 0, 0), new DateTime(2012, 3, 29, 15, 0, 0), "Documentation")
            {
                Children = { documentationTaskChild1, documentationTaskChild2, documentationTaskChild3, documentationTaskChild4, documentationTaskChild5, documentationTaskChild6, documentationTaskChild7, documentationTaskChild8, documentationTaskChild9 }
            };
            this.Add(documentationTask);

            var pilotTaskChild1 = new GanttTask(new DateTime(2012, 1, 26, 8, 0, 0), new DateTime(2012, 1, 27, 17, 0, 0), "Identify test group");
            var pilotTaskChild2 = new GanttTask(new DateTime(2012, 1, 27, 12, 0, 0), new DateTime(2012, 1, 28, 12, 0, 0), "Develop software delivery mechanism");
            var pilotTaskChild3 = new GanttTask(new DateTime(2012, 4, 24, 13, 0, 0), new DateTime(2012, 4, 25, 12, 0, 0), "Install/deploy software");
            var pilotTaskChild4 = new GanttTask(new DateTime(2012, 4, 25, 15, 0, 0), new DateTime(2012, 5, 2, 15, 0, 0), "Obtain user feedback");
            var pilotTaskChild5 = new GanttTask(new DateTime(2012, 5, 2, 15, 0, 0), new DateTime(2012, 5, 3, 15, 0, 0), "Evaluate testing information");
            var pilotTaskChild6 = new GanttTask(new DateTime(2012, 5, 3, 15, 0, 0), new DateTime(2012, 5, 3, 15, 0, 0), "Pilot complete");

            pilotTaskChild2.Dependencies.Add(new Dependency { FromTask = pilotTaskChild1 });
            pilotTaskChild3.Dependencies.Add(new Dependency { FromTask = pilotTaskChild2 });
            pilotTaskChild4.Dependencies.Add(new Dependency { FromTask = pilotTaskChild3 });
            pilotTaskChild5.Dependencies.Add(new Dependency { FromTask = pilotTaskChild4 });
            pilotTaskChild6.Dependencies.Add(new Dependency { FromTask = pilotTaskChild5 });

            var pilotTask = new GanttTask(new DateTime(2012, 1, 26, 8, 0, 0), new DateTime(2012, 5, 3, 15, 0, 0), "Pilot")
            {
                Children = { pilotTaskChild1, pilotTaskChild2, pilotTaskChild3, pilotTaskChild4, pilotTaskChild5, pilotTaskChild6 }
            };
            this.Add(pilotTask);

            var deploymentTaskChild1 = new GanttTask(new DateTime(2012, 5, 3, 15, 0, 0), new DateTime(2012, 5, 4, 15, 0, 0), "Determine final deployment strategy");
            var deploymentTaskChild2 = new GanttTask(new DateTime(2012, 5, 4, 15, 0, 0), new DateTime(2012, 5, 5, 15, 0, 0), "Develop deployment methodology");
            var deploymentTaskChild3 = new GanttTask(new DateTime(2012, 5, 5, 15, 0, 0), new DateTime(2012, 5, 8, 15, 0, 0), "Secure deployment resources");
            var deploymentTaskChild4 = new GanttTask(new DateTime(2012, 5, 8, 15, 0, 0), new DateTime(2012, 5, 9, 15, 0, 0), "Train support staff");
            var deploymentTaskChild5 = new GanttTask(new DateTime(2012, 5, 9, 15, 0, 0), new DateTime(2012, 5, 10, 15, 0, 0), "Deploy software");
            var deploymentTaskChild6 = new GanttTask(new DateTime(2012, 5, 10, 15, 0, 0), new DateTime(2012, 5, 10, 15, 0, 0), "Deployment complete");

            deploymentTaskChild2.Dependencies.Add(new Dependency { FromTask = deploymentTaskChild1 });
            deploymentTaskChild3.Dependencies.Add(new Dependency { FromTask = deploymentTaskChild2 });
            deploymentTaskChild4.Dependencies.Add(new Dependency { FromTask = deploymentTaskChild3 });
            deploymentTaskChild5.Dependencies.Add(new Dependency { FromTask = deploymentTaskChild4 });
            deploymentTaskChild6.Dependencies.Add(new Dependency { FromTask = deploymentTaskChild5 });

            var deploymentTask = new GanttTask(new DateTime(2012, 5, 3, 15, 0, 0), new DateTime(2012, 5, 10, 15, 0, 0), "Deployment")
            {
                Children = { deploymentTaskChild1, deploymentTaskChild2, deploymentTaskChild3, deploymentTaskChild4, deploymentTaskChild5, deploymentTaskChild6 }
            };
            this.Add(deploymentTask);

            var reviewTaskChild1 = new GanttTask(new DateTime(2012, 5, 10, 15, 0, 0), new DateTime(2012, 5, 11, 15, 0, 0), "Document lessons learned");
            var reviewTaskChild2 = new GanttTask(new DateTime(2012, 5, 11, 15, 0, 0), new DateTime(2012, 5, 12, 15, 0, 0), "Distribute to team members");
            var reviewTaskChild3 = new GanttTask(new DateTime(2012, 5, 12, 15, 0, 0), new DateTime(2012, 5, 15, 15, 0, 0), "Create software maintenance team");
            var reviewTaskChild4 = new GanttTask(new DateTime(2012, 5, 15, 15, 0, 0), new DateTime(2012, 5, 15, 15, 0, 0), "Post implementation review complete");

            reviewTaskChild2.Dependencies.Add(new Dependency { FromTask = reviewTaskChild1 });
            reviewTaskChild3.Dependencies.Add(new Dependency { FromTask = reviewTaskChild2 });
            reviewTaskChild4.Dependencies.Add(new Dependency { FromTask = reviewTaskChild3 });

            var reviewTask = new GanttTask(new DateTime(2012, 5, 10, 15, 0, 0), new DateTime(2012, 5, 15, 15, 0, 0), "Post Implementation Review")
            {
                Children = { reviewTaskChild1, reviewTaskChild2, reviewTaskChild3, reviewTaskChild4 }
            };
            this.Add(reviewTask);

            var endTask = new GanttTask(new DateTime(2012, 5, 15, 15, 0, 0), new DateTime(2012, 5, 15, 15, 0, 0), "Software development template complete");
            this.Add(endTask);

            softwareRequirementsTaskChild1.Dependencies.Add(new Dependency { FromTask = scopeTaskChild5 });
            designTaskChild1.Dependencies.Add(new Dependency { FromTask = softwareRequirementsTaskChild9 });
            developmentTaskChild1.Dependencies.Add(new Dependency { FromTask = designTaskChild7 });
            testingTaskChild1.Dependencies.Add(new Dependency { FromTask = developmentTaskChild6 });
            trainingTaskChild1.Dependencies.Add(new Dependency { FromTask = testingTaskChild4 });
            documentationTaskChild1.Dependencies.Add(new Dependency { FromTask = trainingTaskChild8 });
            deploymentTaskChild1.Dependencies.Add(new Dependency { FromTask = documentationTaskChild9 });
            reviewTaskChild1.Dependencies.Add(new Dependency { FromTask = documentationTaskChild5 });
            endTask.Dependencies.Add(new Dependency { FromTask = reviewTaskChild3 });
        }
    }
}
